/*
 * Web Designer
 * Copyright (C) 1999-2000  LADISLAS Willhem
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * Author's email : zillprog@freesurf.fr
 * 
 * snailmail : 
 * LADISLAS Willhem
 * 2, rue du Serpolet
 * 95490 VAUREAL
 * FRANCE
 */

#include "common_headers.h"

/*
 * This files contains all the functions concerning the "common" html tags :
 * tag_insert_exec()
 * choose_H()
 * html_comment()
 */

void
insert_path_exec (GtkWidget * w, GtkFileSelection * fs)
{
	gchar *path;

	path = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

	/*
	 * checks if it a directory path instead of a file path 
	 */
	if (path[strlen (path) - 1] == '/')
	  {
		  gtk_widget_destroy (filew);
		  merror (_ ("No file has been selected !"));
		  return;
	  }

	gtk_text_set_point (GTK_TEXT (sheet[curfile].text),
	gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

	gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL, NULL, path, -1);

}
/*
 * fin de insert_path_exec 
 */

void
dialog_insert_path (void)
{

	filew = gtk_file_selection_new (_ ("Insert path..."));

	/*
	 * Connect the ok_button to file_ok_sel function 
	 */
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
				"clicked", (GtkSignalFunc) insert_path_exec, filew);

	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
							   "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

	/*
	 * Connect the cancel_button to destroy the widget 
	 */
	gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
							   "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

	gtk_widget_show (filew);
}
/*
 * fin de dialog_insert_path() 
 */

void
tag_info_exec (int Opcode)
{
	gtk_text_freeze (GTK_TEXT (tag_window));
	gtk_text_set_point (GTK_TEXT (tag_window), 0);
	gtk_text_forward_delete (GTK_TEXT (tag_window), gtk_text_get_length (GTK_TEXT (tag_window)));

	switch (Opcode)
	  {
	  case TAG_FONT:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<FONT SIZE=[1..7] COLOR=[color] FACE=[font]> text </FONT>"), -1);
		  break;

	  case TAG_B:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<B> text </B>"), -1);
		  break;

	  case TAG_I:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<I> text </I>"), -1);
		  break;

	  case TAG_U:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<U> text </U>"), -1);
		  break;

	  case TAG_PRE:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<PRE> text </PRE>"), -1);
		  break;

	  case TAG_P:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<P ALIGN = left|center|right|justify > text </P>"), -1);
		  break;

	  case TAG_COMMENT:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<!-- text -->"), -1);
		  break;

	  case TAG_BIG:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<BIG> text </BIG>"), -1);
		  break;

	  case TAG_SMALL:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<SMALL> text </SMALL>"), -1);
		  break;

	  case TAG_BLINK:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<BLINK> text </BLINK>"), -1);
		  break;

	  case TAG_CITE:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<CITE> text </CITE>"), -1);
		  break;

	  case TAG_HTML:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<HTML> text </HTML>"), -1);
		  break;

	  case TAG_HEAD:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<HEAD> text </HEAD>"), -1);
		  break;

	  case TAG_BODY:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<BODY ALINK=[color] LINK=[color] VLINK=[color] BGCOLOR=[color] TEXT=[color] BACKGROUND=[file] ONLOAD=[script]> text </BODY>"), -1);
		  break;

	  case TAG_TITLE:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<TITLE> text </TITLE>"), -1);
		  break;

	  case TAG_BANNER:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<BANNER> text </BANNER>"), -1);
		  break;

	  case TAG_EM:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<EM> text </EM>"), -1);
		  break;

	  case TAG_STRIKE:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<STRIKE> text </STRIKE>"), -1);
		  break;

	  case TAG_SUP:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<SUP> text </SUP>"), -1);
		  break;

	  case TAG_SUB:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<SUB> text </SUB>"), -1);
		  break;

	  case TAG_TT:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<TT> text </TT>"), -1);
		  break;

	  case TAG_KBD:
		  gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL,
						   _ ("<KBD> text </KBD>"), -1);
		  break;
	  }

	gtk_text_thaw (GTK_TEXT (tag_window));

}
/*
 * fin de tag_info_exec 
 */

void
tag_insert_exec (GtkWidget * widget, int Opcode)
{
	int i, j, x = 0;
	char *text = malloc (150);
	gboolean insert = FALSE;

	if (numfileopened == 0)
		return;

	lasttag_nb = Opcode;

	switch (Opcode)
	  {
	  case TAG_FONT:
		  text = "<FONT></FONT>";
		  tag_info_exec (TAG_FONT);
		  break;

	  case TAG_B:
		  text = "<B></B>";
		  tag_info_exec (TAG_B);
		  break;

	  case TAG_I:
		  text = "<I></I>";
		  tag_info_exec (TAG_I);
		  break;

	  case TAG_U:
		  text = "<U></U>";
		  tag_info_exec (TAG_U);
		  break;

	  case TAG_P:
	  	  text = "<P></P>";
		  tag_info_exec (TAG_P);
		  break;

	  case TAG_P_LEFT:
		  text = "<P ALIGN=\"left\"></P>";
		  tag_info_exec (TAG_P);
		  break;

	  case TAG_P_CENTER:
		  text = "<P ALIGN=\"center\"></P>";
		  tag_info_exec (TAG_P);
		  break;

	  case TAG_P_RIGHT:
		  text = "<P ALIGN=\"right\"></P>";
		  tag_info_exec (TAG_P);
		  break;

	  case TAG_P_JUSTIFY:
		  text = "<P ALIGN=\"justify\"></P>";
		  tag_info_exec (TAG_P);
		  break;

	  case TAG_PRE:
		  text = "<PRE></PRE>";
		  tag_info_exec (TAG_PRE);
		  break;

	  case TAG_BLOCKQUOTE:
		  text = "<BLOCKQUOTE></BLOCKQUOTE>";
		  break;

	  case TAG_BR:
		  text = "<BR>\n";
		  break;

	  case TAG_CENTER:
		  text = "<CENTER></CENTER>";
		  tag_info_exec (TAG_CENTER);
		  break;

	  case TAG_COMMENT:
		  tag_info_exec (TAG_COMMENT);
		  html_comment ();
		  lasttag_nb = Opcode;
		  return;
		  break;

	  case TAG_BIG:
		  text = "<BIG></BIG>";
		  tag_info_exec (TAG_BIG);
		  break;

	  case TAG_SMALL:
		  text = "<SMALL></SMALL>";
		  tag_info_exec (TAG_SMALL);
		  break;

	  case TAG_BLINK:
		  text = "<BLINK></BLINK>";
		  tag_info_exec (TAG_BLINK);
		  break;

	  case TAG_CITE:
		  text = "<CITE></CITE>";
		  tag_info_exec (TAG_CITE);
		  break;

	  case TAG_HTML:
		  text = "<HTML></HTML>";
		  tag_info_exec (TAG_HTML);
		  break;

	  case TAG_HEAD:
		  text = "<HEAD></HEAD>";
		  tag_info_exec (TAG_HEAD);
		  break;

	  case TAG_BODY:
		  text = "<BODY></BODY>";
		  tag_info_exec (TAG_BODY);
		  break;

	  case TAG_TITLE:
		  text = "<TITLE></TITLE>";
		  tag_info_exec (TAG_TITLE);
		  break;

	  case TAG_BANNER:
		  text = "<BANNER></BANNER>";
		  tag_info_exec (TAG_BANNER);
		  break;

	  case TAG_EM:
		  text = "<EM></EM>";
		  tag_info_exec (TAG_EM);
		  break;

	  case TAG_STRIKE:
		  text = "<STRIKE></STRIKE>";
		  tag_info_exec (TAG_STRIKE);
		  break;

	  case TAG_SUP:
		  text = "<SUP></SUP>";
		  tag_info_exec (TAG_SUP);
		  break;

	  case TAG_SUB:
		  text = "<SUB></SUB>";
		  tag_info_exec (TAG_SUB);
		  break;

	  case TAG_TT:
		  text = "<TT></TT>";
		  tag_info_exec (TAG_TT);
		  break;

	  case TAG_KBD:
		  text = "<KBD></KBD>";
		  tag_info_exec (TAG_KBD);
		  break;

	  case TAG_LISTING:
		  text = "<LISTING></LISTING>";
		  break;

	  case TAG_CODE:
		  text = "<CODE></CODE>";
		  break;

	  case TAG_INPUT_PASSWORD:
		  text = "<INPUT TYPE=\"password\" NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_INPUT_TEXT:
		  text = "<INPUT TYPE=\"text\" NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_INPUT_RESET:
		  text = "<INPUT TYPE=\"reset\" VALUE=\"\">";
		  break;

	  case TAG_INPUT_SUBMIT:
		  text = "<INPUT TYPE=\"submit\" VALUE=\"\">";
		  break;

	  case TAG_HR:
		  text = "<HR COLOR=\"\" WIDTH=\"\">";
		  break;

	  case TAG_INPUT_CHECKBOX:
		  text = "<INPUT TYPE=\"checkbox\" NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_INPUT_RADIO:
		  text = "<INPUT TYPE=\"radio\" NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_OL:
		  text = "<OL TYPE=\"\" START=\"\"></OL>";
		  break;

	  case TAG_UL:
		  text = "<UL TYPE=\"\"></UL>";
		  break;

	  case TAG_LI:
		  text = "<LI>";
		  break;

	  case TAG_DD:
		  text = "<DD>";
		  break;

	  case TAG_DT:
		  text = "<DT>";
		  break;

	  case TAG_DL:
		  text = "<DL></DL>";
		  break;

	  case TAG_TEXTAREA:
		  text = "<TEXTAREA COLS=\"\" NAME=\"\" ROWS=\"\" WRAP=\"\"></TEXTAREA>";
		  break;

	  case TAG_FORM:
		  text = "<FORM ACTION=\"\" METHOD=\"\" NAME=\"\"></FORM>";
		  break;

	  case TAG_INPUT_HIDDEN:
		  text = "<INPUT TYPE=\"hidden\" NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_A_HREF:
		  text = "<A HREF=\"\"></A>";
		  break;

	  case TAG_BUTTON:
		  text = "<BUTTON NAME=\"\" TYPE=\"\"></BUTTON>";
		  break;

	  case TAG_H1:
		  text = "<H1></H1>";
		  break;

	  case TAG_H2:
		  text = "<H2></H2>";
		  break;

	  case TAG_H3:
		  text = "<H3></H3>";
		  break;

	  case TAG_H4:
		  text = "<H4></H4>";
		  break;

	  case TAG_H5:
		  text = "<H5></H5>";
		  break;

	  case TAG_H6:
		  text = "<H6></H6>";
		  break;

	  case TAG_IMG:
		  text = "<IMG SRC=\"\" LOWSRC=\"\" ALT=\"\">";
		  break;

	  case TAG_A_NAME:
		  text = "<A NAME=\"\" ></A>";
		  break;

	  case TAG_A_LOCAL:
		  text = "<A HREF=\"#\"></A>";
		  break;

	  case TAG_A_TOP:
		  text = "<A HREF=#top></A>";
		  break;

	  case TAG_DIR:
		  text = "<DIR></DIR>";
		  break;

	  case TAG_MENU:
		  text = "<MENU></MENU>";
		  break;

	  case TAG_TABLE:
		  text = "<TABLE BORDER=\"\"></TABLE>";
		  break;

	  case TAG_TH:
		  text = "<TH></TH>";
		  break;

	  case TAG_TR:
		  text = "<TR></TR>";
		  break;

	  case TAG_TD:
		  text = "<TD></TD>";
		  break;

	  case TAG_CAPTION:
		  text = "<CAPTION></CAPTION>";
		  break;

	  case TAG_FIELDSET:
		  text = "<FIELDSET></FIELDSET>";
		  break;

	  case TAG_APPLET:
		  text = "<APPLET CODE=\"\" HEIGHT=\"\" WIDTH=\"\"></APPLET>";
		  break;

	  case TAG_SCRIPT:
		  text = "<SCRIPT language=\"\"></SCRIPT>";
		  break;

	  case TAG_PARAM:
		  text = "<PARAM NAME=\"\" VALUE=\"\">";
		  break;

	  case TAG_FONT_PLUS:
		  text = "<FONT SIZE=\"+1\"></FONT>";
		  break;

	  case TAG_FONT_MINUS:
		  text = "<FONT SIZE=\"-1\"></FONT>";
		  break;

	  case TAG_BASEFONT:
		  text = "<BASEFONT SIZE=\"\" COLOR=\"\" FACE=\"\">";
		  break;

	  case TAG_STYLE:
		  text = "<STYLE TYPE=\"text/css\"></STYLE>";
		  break;

	  case TAG_BASE_HREF:
		  text = "<BASE HREF=\"\">";
		  break;

	  /*
	   * For Cascading style sheets 
	   */
	  case TAG_DIV:
		  text = "<DIV ID=\"\" CLASS=\"\"></DIV>";
		  break;

	  case TAG_SPAN:
		  text = "<SPAN ID=\"\" CLASS=\"\"></SPAN>";
		  break;

	  case TAG_FRAMESET:
		  text = "<FRAMESET COLS=\"\" ROWS=\"\"></FRAMESET>";
		  break;

	  case TAG_FRAME:
		  text = "<FRAME NAME=\"\" SRC=\"\">";
		  break;

	  case TAG_NOFRAMES:
		  text = "<NOFRAMES></NOFRAMES>";
		  break;

	  case TAG_IFRAME:
		  text = "<IFRAME></IFRAME>";
		  break;

	  }

	j = strlen (text);
	for (i = 0; i < strlen (text); i++)
	  {
		  if (text[j - i] == '<')
			  x = i;
	  }

	/*
	 * for an "intelligent" behavior  -> when the text is highlighted the tags are putted on its left and right 
	 */
	if (GTK_EDITABLE (sheet[curfile].text)->has_selection == 1)
	  {
		  gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
		  insert = TRUE;
	  }

	gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

	gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, text, strlen (text));

	i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));

	gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - x);

	if (insert)
	  {
		  gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
	  }

	if (sheet[curfile].saved == TRUE)
		sheet[curfile].saved = FALSE;

}
/*
 * fin de tag_insert_exec() 
 */

void
repeat_tag (void)
{
	if (lasttag_nb == -1)
	  {
		  return;
	  }
	if (lasttag_nb > 499)
	  {
		  printf ("j");
		  insert_text_and_move_cursor (NULL, lasttag_nb);
	  }
	else
	  {
		  tag_insert_exec (NULL, lasttag_nb);
	  }
}
/*
 * fin de repeat_tag 
 */

void
choose_H (void)
{
	GtkWidget *chooH_window;
	GtkWidget *chooH_frame;
	GtkWidget *chooH_vbox;
	GtkWidget *chooH_button;
	GtkWidget *Bigbox;

	if (numfileopened == 0)
		return;

	chooH_window = gtk_window_new (GTK_WINDOW_POPUP);
	gtk_window_set_title (GTK_WINDOW (chooH_window), _ ("Heading"));

	gtk_window_position (GTK_WINDOW (chooH_window), GTK_WIN_POS_MOUSE);
	chooH_frame = gtk_frame_new (_ (" Heading "));
	gtk_container_border_width (GTK_CONTAINER (chooH_frame), 0);

	Bigbox = gtk_button_new ();

	gtk_signal_connect_object (GTK_OBJECT (Bigbox), "leave", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	gtk_signal_connect_object (GTK_OBJECT (Bigbox), "pressed", GTK_SIGNAL_FUNC (gtk_button_released), GTK_OBJECT (Bigbox));

	gtk_widget_show (Bigbox);

	chooH_vbox = gtk_vbox_new (FALSE, 1);
	gtk_container_border_width (GTK_CONTAINER (chooH_vbox), 2);
	gtk_container_add (GTK_CONTAINER (chooH_window), Bigbox);
	gtk_container_add (GTK_CONTAINER (Bigbox), chooH_frame);
	gtk_container_add (GTK_CONTAINER (chooH_frame), chooH_vbox);
	gtk_widget_show (chooH_vbox);
	gtk_widget_show (chooH_frame);

	chooH_button = gtk_button_new_with_label (_ ("Heading 1"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H1);

	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	chooH_button = gtk_button_new_with_label (_ ("Heading 2"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H2);
	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	chooH_button = gtk_button_new_with_label (_ ("Heading 3"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H3);

	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	chooH_button = gtk_button_new_with_label (_ ("Heading 4"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H4);

	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	chooH_button = gtk_button_new_with_label (_ ("Heading 5"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H5);

	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	chooH_button = gtk_button_new_with_label (_ ("Heading 6"));
	gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
	gtk_widget_show (chooH_button);

	gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) TAG_H6);

	gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

	gtk_widget_show (chooH_window);
}
/*
 * fin de choose_H 
 */

void
html_comment (void)
{
	int i;
	gboolean insert = FALSE;

	if (numfileopened == 0)
		return;

	/*
	 * for an "intelligent" behavior  -> when text is highlighted the tags are putted on its left and right 
	 */
	if (GTK_EDITABLE (sheet[curfile].text)->has_selection == 1)
	  {
		  gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
		  insert = TRUE;
	  }
	gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

	gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, "<!--  -->", 9);
	i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));

	gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - 4);

	if (insert)
	  {
		  gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
	  }

	if (sheet[curfile].saved == TRUE)
		sheet[curfile].saved = FALSE;
}
/*
 * fin de html_comment() 
 */

/*
 * void html_font(void) {
 * int i;
 * 
 * if (numfileopened == 0) return;
 * 
 * gtk_text_freeze(GTK_TEXT(sheet[curfile].text));
 * gtk_text_set_point(GTK_TEXT(sheet[curfile].text), gtk_editable_get_position(GTK_EDITABLE(sheet[curfile].text)));
 * 
 * gtk_text_insert(GTK_TEXT(sheet[curfile].text),fixed_font,NULL,NULL,"<FONT></FONT>",13);
 * i = gtk_text_get_point(GTK_TEXT(sheet[curfile].text));
 * 
 * gtk_editable_set_position(GTK_EDITABLE(sheet[curfile].text), i-7);
 * 
 * gtk_text_thaw(GTK_TEXT(sheet[curfile].text));
 * if (sheet[curfile].saved == TRUE) sheet[curfile].saved = FALSE;
 * }  fin de html_font() 
 */
